/*
   USB Flash Writer Driver
    programmed by M.yanagisawa.(MoroboshiLUM)
    
    Windows98 ddk̃Tvx[XłB
*/

#include "wdm.h"
#include "stdarg.h"
#include "stdio.h"

#include "usbdi.h"
#include "usbdlib.h"
#include "msm60851.h"
#include "GUIDUSB.h"


//hCȍiGg|Cgj
// STATUS_SUCCESS -> OK, STATUS_UNSUCCESSFUL  s
NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject,IN PUNICODE_STRING RegistryPath)
{
    NTSTATUS ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT deviceObject = NULL;
    BOOLEAN fRes;

#if DBG
    // fobOx̃WXg̓ǂݏo
    FlashWr_GetRegistryDword( FLASHWR_REGISTRY_PARAMETERS_PATH, //absolute registry path
                                     L"DebugLevel",     // REG_DWORD ValueName
                                     &gDebugLevel );    // Value receiver
#endif

    FLASHWR_KdPrint( DBGLVL_MINIMUM ,("Entering DriverEntry(), RegistryPath=\n    %ws\n", RegistryPath->Buffer ));

    // 쐬AN[YAA[hp[`̐ڑ
    DriverObject->MajorFunction[IRP_MJ_CREATE] = FlashWr_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE] = FlashWr_Close;
    DriverObject->DriverUnload = FlashWr_Unload;

    // [U[[hDeviceIoControl apǐĂяo[g̐ڑ
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = FlashWr_ProcessIOCTL;

    // [U[[hReadFile/WriteFile apǐĂяo[`̐ڑ
    DriverObject->MajorFunction[IRP_MJ_WRITE] = FlashWr_Write;
    DriverObject->MajorFunction[IRP_MJ_READ] = FlashWr_Read;

    // VXePlug&PlayƓdǗNGXg[`ڑ
    DriverObject->MajorFunction[IRP_MJ_SYSTEM_CONTROL] = FlashWr_ProcessSysControlIrp;
    DriverObject->MajorFunction[IRP_MJ_PNP] = FlashWr_ProcessPnPIrp;
    DriverObject->MajorFunction[IRP_MJ_POWER] = FlashWr_ProcessPowerIrp;

    // PnPfoCXł́Aecn̓foCXhƂɁÃ[`Ă΂܂ō܂
    DriverObject->DriverExtension->AddDevice = FlashWr_PnPAddDevice;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exiting DriverEntry (%x)\n", ntStatus));

    return ntStatus;
}

/*++
    IRP_MJ_SYSTEM_CONTROLp̃CڑifBXpb`je[u
	{Iɂ́AwPDOĂяoB

    DeviceObject - FDOւ̃|C^
    Irp          - I/O NGXgpPbgւ̃|C^

@@߂l͉whCo̖߂l̂́B
--*/
NTSTATUS FlashWr_ProcessSysControlIrp(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp)
{
    PIO_STACK_LOCATION irpStack;
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus = STATUS_SUCCESS;
    NTSTATUS waitStatus;
    PDEVICE_OBJECT stackDeviceObject;

    Irp->IoStatus.Status = STATUS_SUCCESS;
    Irp->IoStatus.Information = 0;

    //
    // IRP݂̌̈ʒuւ̃|C^擾܂.@Ŋ֐p[^P[g܂
    //

    irpStack = IoGetCurrentIrpStackLocation (Irp);

    //
    // foCXGNXeVւ̃|C^擾܂
    //

    deviceExtension = DeviceObject->DeviceExtension;
    stackDeviceObject = deviceExtension->TopOfStackDeviceObject;

    FLASHWR_KdPrint( DBGLVL_HIGH, ( "enter FlashWr_ProcessSysControlIrp()\n") );

    FlashWr_IncrementIoCount(DeviceObject);//QƃJE^{P

    FLASHWR_ASSERT( IRP_MJ_SYSTEM_CONTROL == irpStack->MajorFunction );

    IoCopyCurrentIrpStackLocationToNext(Irp); // 


    ntStatus = IoCallDriver(stackDeviceObject,Irp);  // whCoĂяo

    FlashWr_DecrementIoCount(DeviceObject);//QƃJE^|P

    FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_ProcessSysControlIrp() Exit FlashWr_ProcessSysControlIrp %x\n", ntStatus));

    return ntStatus;
}


/*++
    \[XăhCoA[h܂B
    DriverObject : hCoIuWFNgւ̃|C^
--*/
VOID FlashWr_Unload(IN PDRIVER_OBJECT DriverObject)
{
    FLASHWR_KdPrint( DBGLVL_HIGH,("enter FlashWr_Unload\n"));

    // hCoGgŊmۂO[o\[Xŉ܂B
	// APnPfoCXł݂͂̂͑ȂA킸łB
	// ́APnPfoCXł PnpAddDeviceŃhCoNA
	// IRP_MN_REMOVE_DEVICEŉ邩łB
	FLASHWR_ASSERT( gExAllocCount == 0 );

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("exit FlashWr_Unload\n"));

}


/*++

Routine Description:

    ̃[`́AGUIDx[X̃V{bNNŁA[U[[h玩g
    CX^X쐬EI[v̂łB

    FlashWr_CreateDeviceObjectĂ΂܂

:

    DeviceObject - foCXIuWFNg( PDO )ւ̃|C^

    deviceLinkUnicodeString - ĂяoŊmۂꂽUnicodeւ̃|C^
        當ÃhCoւ̃J[l[hł̃pXւ̃V{bNN
        Ɋi[܂B

Ԃl:

    ȂSTATUS_SUCCESSsȂSTATUS_UNSUCCESSFULԂB

--*/ 
NTSTATUS FlashWr_SymbolicLink(IN PDEVICE_OBJECT DeviceObject,IN OUT PUNICODE_STRING deviceLinkUnicodeString)
{
    NTSTATUS ntStatus = STATUS_SUCCESS;


    //  V{bNN̍쐬
     
    // IoRegisterDeviceInterface̓AvP[V⑼̃VXeR|[lg
    // hCog悤ɂ@\IfoCXAfoCXC^[tFCXo^܂B

    ntStatus = IoRegisterDeviceInterface(DeviceObject,(LPGUID)&GUID_CLASS_FLASHWRITER, NULL,deviceLinkUnicodeString);

    FLASHWR_KdPrintCond( DBGLVL_MEDIUM, (!(NT_SUCCESS(ntStatus))),
            ("FAILED to IoRegisterDeviceInterface()\n"));

   if (NT_SUCCESS(ntStatus)) {

       // IoSetDeviceInterfaceState͐ɓo^ꂽfoCXC^[tFCX֎~苖
       // 肵܂BAvP[VƂ̑̃VXeR|[lǵAꂽC^[tFCX
       // ݂̂JƂł܂B

        ntStatus = IoSetDeviceInterfaceState(deviceLinkUnicodeString, TRUE);

        FLASHWR_KdPrintCond( DBGLVL_MEDIUM,
                (!(NT_SUCCESS(ntStatus))),
                ("FAILED to IoSetDeviceInterfaceState()\n"));

        FLASHWR_KdPrintCond( DBGLVL_MEDIUM,
                ((NT_SUCCESS(ntStatus))),
                ("SUCCEEDED  IoSetDeviceInterfaceState()\n"));

    }

    return ntStatus;
}



/*++
    @\foCXIuWFNg(FDo)쐬܂

:
    DriverObject - foCX̃hCo[IuWFNgւ̃|C^
    DeviceObject - ԋp쐬ꂽfoCXIuWFNgւ̃|C^

Ԃl:
    ȂSTATUS_SUCCESSAsȂ STATUS_UNSUCCESSFULԂ
--*/
NTSTATUS FlashWr_CreateDeviceObject(IN PDRIVER_OBJECT DriverObject,IN PDEVICE_OBJECT PhysicalDeviceObject,IN PDEVICE_OBJECT *DeviceObject)
{
    NTSTATUS ntStatus;
    UNICODE_STRING deviceLinkUnicodeString;
    PDEVICE_EXTENSION deviceExtension;
    USHORT i;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("enter FlashWr_CreateDeviceObject() \n"));

// V{bNNPDO擾
    ntStatus = FlashWr_SymbolicLink( PhysicalDeviceObject, &deviceLinkUnicodeString );

    FLASHWR_KdPrintCond( DBGLVL_DEFAULT,
            (NT_SUCCESS(ntStatus)),
            ("FlashWr_CreateDeviceObject() SUCCESS Create GUID_CLASS_FlashWr_BULK-based Device name\n   %ws\n Length decimal %d, MaximumLength decimal %d\n",
            deviceLinkUnicodeString.Buffer,
            deviceLinkUnicodeString.Length,
            deviceLinkUnicodeString.MaximumLength));

    FLASHWR_KdPrintCond( DBGLVL_DEFAULT,
            (!(NT_SUCCESS(ntStatus))),
            ("FlashWr_CreateDeviceObject() FAILED to Create GUID_CLASS_FlashWr_BULK-based Device name\n"));

    if (NT_SUCCESS(ntStatus)) {

//  foCXIuWFNg̍쐬
        ntStatus = IoCreateDevice (DriverObject,
                           sizeof (DEVICE_EXTENSION),
                           NULL,
                           FILE_DEVICE_UNKNOWN,
                           FILE_AUTOGENERATED_DEVICE_NAME,
                           FALSE,
                           DeviceObject);

        if (NT_SUCCESS(ntStatus))  {
             deviceExtension = (PDEVICE_EXTENSION) ((*DeviceObject)->DeviceExtension);

        }

        FLASHWR_KdPrintCond( DBGLVL_DEFAULT,
                (!(NT_SUCCESS(ntStatus))),
                ("FlashWr_CreateDeviceObject() IoCreateDevice() FAILED\n"));

 
        if (!NT_SUCCESS(ntStatus))  {
             return ntStatus;
        }


        //PXe[W̃ftHg̍ő]TCYNGXgɐݒ
        deviceExtension->MaximumTransferSize =  FLASHWR_MAX_TRANSFER_SIZE ;

#if DBG
        // WXg̒lŃI[o[ChifobOpj
        FlashWr_GetRegistryDword( FLASHWR_REGISTRY_PARAMETERS_PATH,
                                         L"MaximumTransferSize",
                                         &(deviceExtension->MaximumTransferSize) );
#endif

        // g̋@\foCXIuWFNg̃N𖼕tĂl[obt@
        // ̖O̓hCõNXGUIDɊÂĐ
        RtlCopyMemory(deviceExtension->DeviceLinkNameBuffer,
                      deviceLinkUnicodeString.Buffer,
                      deviceLinkUnicodeString.Length);


        // ̃Cxg͂ǂȎނ̏IĂȂo͂ȂƂA邢̓foCX[uꂽ
        // Ƃɔ̂łB
        KeInitializeEvent(&deviceExtension->RemoveEvent, NotificationEvent, FALSE);

        // ̃Cxg͎̃NGXgdIRPƂɔ
        KeInitializeEvent(&deviceExtension->SelfRequestedPowerIrpEvent, NotificationEvent, FALSE);

        // ̃Cxg FlashWr_AsyncReadWrite_Complete() Ō̓o͂̃Xe[WI
        // LZƂɔB
        KeInitializeEvent(&deviceExtension->StagingDoneEvent, NotificationEvent, FALSE);

        // ̃Cxg I̓o͂ȂȂƂiIo == 1 )̂Ƃɔ
        KeInitializeEvent(&deviceExtension->NoPendingIoEvent, NotificationEvent, FALSE);

		// SpinLockI/OJE^ZAZWbN𓯊邽߂̃bNɎĝł
		KeInitializeSpinLock (&deviceExtension->IoCountSpinLock);

		//C^[tFCX̏ɎgUNICODẼobt@܂
		RtlFreeUnicodeString( &deviceLinkUnicodeString );
    }


    return ntStatus;
}


/*++
Routine Description:

    URBUSBDNXhCoɒʉ߂܂B
	NCAgfoCXhCoUSBNGXgubN(URB)\̂
	Irp->MajorFunctionIRP_MJ_INTERNAL_DEVICE_CONTROLZbgA
	IRPX^bNʒuParameters.DeviceIoControl.IoControlCodetB[h
	IOCTL_INTERNAL_USB_SUBMIT_URBZbgĂIRPp[^
	ƂăNXhCoɒʉ߂܂B

:

    DeviceObject - foCXIuWFNg(PDO)ւ̃|C^
    Urb - ɐݒ肳ĂURBNGXgubNւ̃|C^

Ԃl:

    ƂSTATUS_SUCCESSAȊOSTATUS_UNSUCCESSFULԂ

--*/
NTSTATUS
FlashWr_CallUSBD(IN PDEVICE_OBJECT DeviceObject,IN PURB Urb)
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("enter FlashWr_CallUSBD\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    //
    // VNiCYNGXg̔s
    //

    KeInitializeEvent(&event, NotificationEvent, FALSE);

    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_SUBMIT_URB,
                deviceExtension->TopOfStackDeviceObject, //ɒʂ̃hCõfoCXIuWFNgւ̃|C^
                NULL, // IvV̓̓obt@ił͕KvȂj
                0,	  // gȂ̓obt@̒ݒ
                NULL, // IvV̏o̓obt@ił͕KvȂj
                0,    // gȂo̓obt@̒ݒ
                TRUE, // InternalDeviceControlTRUEȂ΁A^[QbghCoIRP_MJ_INTERNAL_DEVICE_CONTROL
                	  // 邢IRP_MJ_SCSĨfBXpb`Ă΂B̑́AIRP_MJ_DEVICE_CONTROL̃fBX
                	  // pb`[`Ă΂B
                &event,     // IɃVOiԂɂȂCxgnh
                &ioStatus);  // NGXgʂ̃hCoŊƂZbgI/OXe[^XubNݒ肷

    //
    // sNXhCoĂяo.  ԂlPENDINGȂANGXg܂ő҂
    //

    nextStack = IoGetNextIrpStackLocation(irp);
    FLASHWR_ASSERT(nextStack != NULL);

    // URBUSBhCoX^bNɒʂ
    nextStack->Parameters.Others.Argument1 = Urb;

    ntStatus = IoCallDriver(deviceExtension->TopOfStackDeviceObject, irp);

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_CallUSBD() return from IoCallDriver USBD %x\n", ntStatus));

    if (ntStatus == STATUS_PENDING) {

        status = KeWaitForSingleObject(
                       &event,
                       Suspended,
                       KernelMode,
                       FALSE,
                       NULL);

    } else {
        ioStatus.Status = ntStatus;
    }

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("FlashWr_CallUSBD() URB status = %x status = %x irp status %x\n",
        Urb->UrbHeader.Status, status, ioStatus.Status));

    //
    // USBD͎g̃G[R[h}bv܂
    //
    ntStatus = ioStatus.Status;

    FLASHWR_KdPrintCond( DBGLVL_MAXIMUM, !NT_SUCCESS( ntStatus ), ("exit FlashWr_CallUSBD FAILED (%x)\n", ntStatus));

    return ntStatus;
}


/*++
    USB̃foCX̎擾CX^XAIAݒۑ܂B

:
    DeviceObject - tratbVC^̃CX^X̂߂̕foCXIuWFNg̃|C^
Ԃl:
    NTXe[^XR[h
--*/
NTSTATUS FlashWr_ConfigureDevice(IN  PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb;
    ULONG siz;

    FLASHWR_KdPrint( DBGLVL_HIGH,("enter FlashWr_ConfigureDevice\n"));

    deviceExtension = DeviceObject->DeviceExtension;

	FLASHWR_ASSERT( deviceExtension->UsbConfigurationDescriptor == NULL );

    urb = FLASHWR_ExAllocatePool(NonPagedPool,
                         sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));
	if ( !urb )
		return STATUS_INSUFFICIENT_RESOURCES;

	// USB_CONFIGURATION_DESCRIPTOR_TYPEUsbBuildGetDescriptorRequest()̌Ăяoɂ
	// fXNv^^CvŎw肳ꂽƂAݒ̂߂ׂ̂ẴC^[tFCXA
	// Gh|CgNX̏ڍׁAx_̏ڍׂ̃fXNv^߂B
	// Ăяoׂ͂̏ĕێ̂ɏ\ȑ傫̃obt@mۂ
	// ΂ȂȂBāÃf[^̓G[Ȃɐ؂߂邱ƂɂȂB
	// 䂦A'siz' ͒xɂȂBǂ̓gCȂ΂ȂȂ̂ł͂邯ǂB

    siz = sizeof(USB_CONFIGURATION_DESCRIPTOR) + 512;  

	// UsbBuildGetDescriptorRequestdeviceExtension->UsbConfigurationDescriptorɐ؂߂
	// Ƃ̂Ȃ炢̂҂̃obt@TCYɂȂƂɁA[vEo邱ƂɂȂ܂
	while( 1 ) {

		deviceExtension->UsbConfigurationDescriptor = FLASHWR_ExAllocatePool(NonPagedPool, siz);

		if ( !deviceExtension->UsbConfigurationDescriptor ) {
		    FLASHWR_ExFreePool(urb);
			return STATUS_INSUFFICIENT_RESOURCES;
		}

		UsbBuildGetDescriptorRequest(urb,
									 (USHORT) sizeof (struct _URB_CONTROL_DESCRIPTOR_REQUEST),
									 USB_CONFIGURATION_DESCRIPTOR_TYPE,
									 0,
									 0,
									 deviceExtension->UsbConfigurationDescriptor,
									 NULL,
									 siz,
									 NULL);

		ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

		FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_CallUSBD() Configuration Descriptor = %x, len %x\n",
						deviceExtension->UsbConfigurationDescriptor,
						urb->UrbControlDescriptorRequest.TransferBufferLength));
		//
		// \Ȃ瓯f[^B
		// NOTE: obt@[I[o[̂URBɃG[󂯎
		if (urb->UrbControlDescriptorRequest.TransferBufferLength>0 &&
				deviceExtension->UsbConfigurationDescriptor->wTotalLength > siz) {

			siz = deviceExtension->UsbConfigurationDescriptor->wTotalLength;
			FLASHWR_ExFreePool(deviceExtension->UsbConfigurationDescriptor);
			deviceExtension->UsbConfigurationDescriptor = NULL;
		} else {
			break;  // ŏɂƂ邾[B
		}

	} // end, while (retry loop )

    FLASHWR_ExFreePool(urb);
	FLASHWR_ASSERT( deviceExtension->UsbConfigurationDescriptor );

    //
    // 擾ݒ̃RtBO[VfXNv^ێ
    // ŁAݒƊ֘ApCv擾邽߁ASelectConfigration
    // R}hUSBfoCXɔs킯:)
    //
    ntStatus = FlashWr_SelectInterface(DeviceObject,
        deviceExtension->UsbConfigurationDescriptor);


    FLASHWR_KdPrint( DBGLVL_HIGH,("exit FlashWr_ConfigureDevice (%x)\n", ntStatus));

    return ntStatus;
} 


/*++
    MSM60581΃C^[tFCX܂B
	̃hCo͂PC^[tFCXT|[gĂ܂񂯂ǁiAGh|Cg
	͕܂ŁBł̃tbVC^̓Gh|CgPgȂłǂ(^^;

:
    DeviceObject - tbVC^̃CX^X̂߂̃foCXIuWFNgւ̃|C^
    ConfigurationDescriptor - C^[tFCXAGh|CgAfXNv^܂USB
							  RtBO[VfXNv^ւ̃|C^
Ԃl:
    NT Xe[^XR[h

--*/
NTSTATUS
FlashWr_SelectInterface(
    IN PDEVICE_OBJECT DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    )
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb = NULL;
    ULONG i;
    PUSB_INTERFACE_DESCRIPTOR interfaceDescriptor = NULL;
	PUSBD_INTERFACE_INFORMATION Interface = NULL;
    USHORT siz;

    FLASHWR_KdPrint( DBGLVL_MEDIUM,("enter FlashWr_SelectInterface\n"));

    deviceExtension = DeviceObject->DeviceExtension;


    FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_SelectInterface() called with NULL Interface\n"));
    //
    // FlashWrhCo͂P̃C^[tFCXT|[g܂B̃C^[tFCX
    // RtBO[VfXNv^͂ÃpCvL܂
    //

    urb = USBD_CreateConfigurationRequest(ConfigurationDescriptor, &siz);

    if (urb) {

		//
		// USBD_ParseConfigurationDescriptorEx͗^ꂽRtBO[VfXNv^
		// A}b`C^[tFCXւ̃|C^Ԃ܂B
		// Ƃ킢ĂAtbVC^̃C^[tFCX͂PȂԂ邩ԂȂȂ
		// ł(^^;
		//
        interfaceDescriptor =
            USBD_ParseConfigurationDescriptorEx(ConfigurationDescriptor,
								  ConfigurationDescriptor, //RtBO[VfXNv^̍ŏ猟
								  -1,	// C^[tFCXԍ͎QƂȂiPȂ̂Łj
								  -1,   // alternate setting͖
								  -1,   // C^[tFCXNX
								  -1,   // TuNX
								  -1    // C^[tFCXvgR
								  );

		if ( !interfaceDescriptor ) {

			FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_SelectInterface() ParseConfigurationDescriptorEx() failed\n  returning STATUS_INSUFFICIENT_RESOURCES\n"));
			FLASHWR_ExFreePool(urb);
			return STATUS_INSUFFICIENT_RESOURCES;
		}
		//C^[tFCXL(^^)
        Interface = &urb->UrbSelectConfiguration.Interface;

        for (i=0; i< Interface->NumberOfPipes; i++) {
            //
            // łȃpCv̏s
            //
            Interface->Pipes[i].MaximumTransferSize = deviceExtension->MaximumTransferSize;
            Interface->Pipes[i].PipeFlags = 0;
        }

        UsbBuildSelectConfigurationRequest(urb,
                                          (USHORT) siz,
                                          ConfigurationDescriptor);


        ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

        deviceExtension->UsbConfigurationHandle =
            urb->UrbSelectConfiguration.ConfigurationHandle;

    } else {
        FLASHWR_KdPrint( DBGLVL_HIGH,("FlashWr_SelectInterface() USBD_CreateConfigurationRequest() failed\n  returning STATUS_INSUFFICIENT_RESOURCES\n"));
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
    }


    if (NT_SUCCESS(ntStatus)) {

        //
        // ̃foCX̂߂̐ݒnhۑ
        //

        deviceExtension->UsbConfigurationHandle =
            urb->UrbSelectConfiguration.ConfigurationHandle;

        deviceExtension->UsbInterface = FLASHWR_ExAllocatePool(NonPagedPool,
                                                    Interface->Length);

        if (deviceExtension->UsbInterface) {
            ULONG j;

            //
            // C^[tFCX̃Rs[ۑ
            //
            RtlCopyMemory(deviceExtension->UsbInterface, Interface, Interface->Length);

            //
            // C^[tFCX\ifobOpj
            //
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("---------\n"));
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("NumberOfPipes 0x%x\n", deviceExtension->UsbInterface->NumberOfPipes));
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("Length 0x%x\n", deviceExtension->UsbInterface->Length));
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("Alt Setting 0x%x\n", deviceExtension->UsbInterface->AlternateSetting));
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("Interface Number 0x%x\n", deviceExtension->UsbInterface->InterfaceNumber));
            FLASHWR_KdPrint( DBGLVL_MEDIUM,("Class, subclass, protocol 0x%x 0x%x 0x%x\n",
                deviceExtension->UsbInterface->Class,
                deviceExtension->UsbInterface->SubClass,
                deviceExtension->UsbInterface->Protocol));

            // pCv_v

            for (j=0; j<Interface->NumberOfPipes; j++) {
                PUSBD_PIPE_INFORMATION pipeInformation;

                pipeInformation = &deviceExtension->UsbInterface->Pipes[j];

                FLASHWR_KdPrint( DBGLVL_MEDIUM,("---------\n"));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("PipeType 0x%x\n", pipeInformation->PipeType));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("EndpointAddress 0x%x\n", pipeInformation->EndpointAddress));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("MaxPacketSize 0x%x\n", pipeInformation->MaximumPacketSize));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("Interval 0x%x\n", pipeInformation->Interval));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("Handle 0x%x\n", pipeInformation->PipeHandle));
                FLASHWR_KdPrint( DBGLVL_MEDIUM,("MaximumTransferSize 0x%x\n", pipeInformation->MaximumTransferSize));
            }

            FLASHWR_KdPrint( DBGLVL_MEDIUM,("---------\n"));
        }
    }

    if (urb) {
		// ̃obt@USBD_CreateConfigurationRequestɂmۂĂ
    	// FLASHWR_ExFreePoolĂł͂ȂI
    	// FLASHWR_ExAllocatePool͕ʁB
        ExFreePool(urb);
    }
    FLASHWR_KdPrint( DBGLVL_HIGH,("exit FlashWr_SelectInterface (%x)\n", ntStatus));

    return ntStatus; 
}


/*++
    ^ꂽUSBpCvZbg

	l:
    ̓zXgf[^OɃZbg܂AfoCXf[^OɃZbgׂB 

:
    DeviceObject - FDO
    PipeInfo - USBD_PIPE_INFORMATION\̂ւ̃|C^
Ԃl:
    NTXe[^XR[h
--*/

NTSTATUS FlashWr_ResetPipe(IN PDEVICE_OBJECT DeviceObject,IN PUSBD_PIPE_INFORMATION PipeInfo)
{
    NTSTATUS ntStatus;
    PURB urb;
    PDEVICE_EXTENSION deviceExtension;

    deviceExtension = DeviceObject->DeviceExtension;

    FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetPipe() Reset Pipe %x\n", PipeInfo));

    urb = FLASHWR_ExAllocatePool(NonPagedPool,
                         sizeof(struct _URB_PIPE_REQUEST));

    if (urb) {

        urb->UrbHeader.Length = (USHORT) sizeof (struct _URB_PIPE_REQUEST);
        urb->UrbHeader.Function = URB_FUNCTION_RESET_PIPE;
        urb->UrbPipeRequest.PipeHandle =
            PipeInfo->PipeHandle;

        ntStatus = FlashWr_CallUSBD(DeviceObject, urb);

        FLASHWR_ExFreePool(urb);

    } else {
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
    }

    if (!(NT_SUCCESS(ntStatus))) {
#if DBG
		if ( gpDbg )
			gpDbg->PipeErrorCount++;
#endif

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetPipe() FAILED, ntStatus =0x%x\n", ntStatus ));
    }
    else {
#if DBG
		if ( gpDbg )
			gpDbg->ResetPipeCount++;
#endif

        FLASHWR_KdPrint( DBGLVL_DEFAULT,("FlashWr_ResetPipe() SUCCESS, ntStatus =0x%x\n", ntStatus ));
    }

    return ntStatus;
}



/*++
        hCoDeviceExtention̖̒I/O̐( extension->PendingIoCount )ێ܂
        ̃JEg̍ŏ̉Z̓foCX̒ǉs܂B
        
        ̂ƁÃJEg͊eX̐VIRPMŉZAeXIRPAʉ߂Ƃ
        Z܂B

        ܂́APւ̑JڂƂI/OȂƂ̂ӖAdeviceExtension->NoPendingIoEvent
        VOiԂɂ킯łBIRP_MN_QUERY_REMOVE_DEVICȄɕKvłB

        Oւ̑Jڂ̓Cxg(deviceExtension->RemoveEvent)VOiԂɂAfoCX[u
        \ɂ܂BIRP_MN_REMOVE_DEVICȄɕKvłB
 
:

        DeviceObject - FDOւ̃|C^

Ԃl:

        deviceExtension->PendingIoCount@I/O̐

--*/
LONG FlashWr_DecrementIoCount(IN PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    LONG ioCount;
    KIRQL             oldIrql;

    deviceExtension = DeviceObject->DeviceExtension;
	KeAcquireSpinLock (&deviceExtension->IoCountSpinLock, &oldIrql);

    ioCount = InterlockedDecrement(&deviceExtension->PendingIoCount);
#if DBG
    InterlockedDecrement(&gpDbg->PendingIoCount);
#endif


    FLASHWR_TrapCond( DBGLVL_HIGH,( 0 > ioCount ) );

    if (ioCount==1) {
        // I/OȂȂƂ̃gK[ł
        KeSetEvent(&deviceExtension->NoPendingIoEvent,
                   1,
                   FALSE);
    }

    if (ioCount==0) {
        // [ufoCXCxg̃gK[ł
        KeSetEvent(&deviceExtension->RemoveEvent,
                   1,
                   FALSE);
    }
	KeReleaseSpinLock (&deviceExtension->IoCountSpinLock, oldIrql);

    FLASHWR_KdPrint( DBGLVL_HIGH,("Exit FlashWr_DecrementIoCount() Pending io count = %x\n", ioCount));
    return ioCount;
}


/*++

Routine Description:

        hCoDeviceExtention̖̒I/O̐( extension->PendingIoCount )ێ܂
        ̃JEg̍ŏ̉Z̓foCX̒ǉs܂B

        ̂ƁÃJEg͊eX̐VIRPMŉZAeXIRPAʉ߂Ƃ
        Z܂B

:
        DeviceObject -- FDOւ̃|C^
Ԃl:
        None


--*/
VOID FlashWr_IncrementIoCount(IN PDEVICE_OBJECT DeviceObject)
{
    PDEVICE_EXTENSION deviceExtension;
    KIRQL             oldIrql;

    deviceExtension = DeviceObject->DeviceExtension;

    FLASHWR_KdPrint( DBGLVL_MAXIMUM,("Enter FlashWr_IncrementIoCount() Pending io count = %x\n", deviceExtension->PendingIoCount));

	KeAcquireSpinLock (&deviceExtension->IoCountSpinLock, &oldIrql);

    InterlockedIncrement(&deviceExtension->PendingIoCount);
#if DBG
    InterlockedIncrement(&gpDbg->PendingIoCount);
#endif
	KeReleaseSpinLock (&deviceExtension->IoCountSpinLock, oldIrql);

    FLASHWR_KdPrint( DBGLVL_HIGH,("Exit FlashWr_IncrementIoCount() Pending io count = %x\n", deviceExtension->PendingIoCount));
}

